/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.service;

import java.util.Map;

import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort.Direction;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.portofolio.base.BaseServiceImpl;
import com.portofolio.dao.DesaKelurahanDao;
import com.portofolio.dto.DesaKelurahanDto;
import com.portofolio.entity.DesaKelurahan;
import com.portofolio.entity.vo.DesaKelurahanId;
import com.portofolio.exception.InfoException;
import com.portofolio.util.CommonUtil;


@Lazy
@Service
public class DesaKelurahanService extends BaseServiceImpl {

	@Lazy
	@Autowired
	private DesaKelurahanDao desakelurahanDao;

	@Lazy
	@Autowired
	private LoginUserService loginUserService;
	
	@Lazy
	@Autowired
	private LanguageService languageService;

	@Transactional
	public Map<String, Object> save(DesaKelurahanDto desakelurahanDto) {
		result.clear();
		DesaKelurahanId id = new DesaKelurahanId();
		id.setKdDesaKelurahan(getIdTerahirByNegara(DesaKelurahan.class, "kdDesaKelurahan"));
		id.setKdNegara(getKdNegara());

		DesaKelurahan desakelurahan = CommonUtil.findOne(desakelurahanDao, id);
		if (CommonUtil.isNullOrEmpty(desakelurahan)) {
			desakelurahan = new DesaKelurahan();
			BeanUtils.copyProperties(desakelurahanDto, desakelurahan);
			desakelurahan.setNoRec(generateUuid32());
			desakelurahan.setVersion(1);
			desakelurahan.setId(id);
			desakelurahan = desakelurahanDao.save(desakelurahan);
			result.put("desaKelurahan", desakelurahan);
			resultCreated();
		} else {
			throw new InfoException(languageService.getTranslateByKey("desaKelurahan.message.dataAlreadyExist"));
		}

		return result;
	}

	@Transactional
	public Map<String, Object> update(DesaKelurahanDto desakelurahanDto, Integer kdDesaKelurahan, Integer version) {
		result.clear();
		DesaKelurahanId id = new DesaKelurahanId();
		id.setKdDesaKelurahan(kdDesaKelurahan);
		id.setKdNegara(getKdNegara());
		DesaKelurahan desakelurahan = CommonUtil.findOne(desakelurahanDao, id);
		if (CommonUtil.isNotNullOrEmpty(desakelurahan)) {
			if (version < desakelurahan.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			BeanUtils.copyProperties(desakelurahanDto, desakelurahan);
			desakelurahan.setVersion(version);
			desakelurahan = desakelurahanDao.save(desakelurahan);
			result.put("desaKelurahan", desakelurahan);
			resultUpdated();
		} else {
			resultNotFound();
		}

		return result;
	}

	
	public Map<String, Object> grid(Integer page, Integer limit, String sort, String dir, String namadesakelurahan,boolean statusEnabled) {
		result.clear();
		page--;
		PageRequest pageReq = PageRequest.of(page, limit, "desc".equals(sort) ? Direction.DESC : Direction.ASC, dir);
		Page<Map<String, Object>> pageRes;
		if (CommonUtil.isNullOrEmpty(namadesakelurahan)) {
			pageRes = desakelurahanDao.findAllList(getKdNegara(), statusEnabled, pageReq);
		} else {
			pageRes = desakelurahanDao.findAllList(getKdNegara(), namadesakelurahan, statusEnabled, pageReq);
		}
		result.put("desaKelurahan", pageRes.getContent());
		result.put("totalPages", pageRes.getTotalPages());
		result.put("totalRow", pageRes.getTotalElements());
		resultSuccessful();

		return result;
	}

	
	public Map<String, Object> findByKdDesaKelurahan(Integer kdDesaKelurahan) {
		result.clear();
		Map<String, Object> desakelurahan = desakelurahanDao.findByKode(getKdNegara(), kdDesaKelurahan,CONSTANT_STATUS_ENABLED_TRUE);
		result.put("desaKelurahan", desakelurahan);
		resultSuccessful();

		return result;
	}

	@Transactional
	public Map<String, Object> deleteById(Integer kdDesaKelurahan, Integer version) {
		DesaKelurahanId id = new DesaKelurahanId();
		id.setKdDesaKelurahan(kdDesaKelurahan);
		id.setKdNegara(getKdNegara());
		DesaKelurahan desakelurahan = CommonUtil.findOne(desakelurahanDao, id);
		if (CommonUtil.isNotNullOrEmpty(desakelurahan)) {
			if (version < desakelurahan.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			desakelurahan.setStatusEnabled(false);
			desakelurahan = desakelurahanDao.save(desakelurahan);
			result.put("message", "berhasil.dihapus");
			result.put("desaKelurahan", desakelurahan);
			resultDeleted();
		} else {
			resultNotFound();
		}

		return result;
	}

	
	public Map<String, Object> findByKdKecamatan(Integer kdKecamatan) {
		result.clear();
		result.put("desaKelurahan",desakelurahanDao.findByKdKecamatan(getKdNegara(), kdKecamatan, CONSTANT_STATUS_ENABLED_TRUE));
		resultSuccessful();
		return result;
	}

}
